
;;Compilar con Masm as.
;ML /c txdcom1.asm
;DOSLNK/MAP txdcom1.obj;

; COSTANTE DEFINIDA PARA EL PROGRAMA:
        CR      EQU   0DH     ;codigo Ascii de tecla <Envio>
        LF      EQU   0AH     ;codigo Ascii de tecla <Envio>
        ESC_    EQU    27     ;codigo de tecla <ESC>

;=============================================================================
;DEFINICION DEL SEGMENTO DEL CODIGO                                        
;=============================================================================
_prog   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_prog,DS:_prog

;       ORG     0100H
INIZIO: JMP     TxD0Com1

;=============================================================================
;AREA DESTINADA A LA DATA DEL PROGRAMA                                       
;=============================================================================
DatTxD  DB ? 


Testo   DB CR,LF,"TxD0Com1 - TRANSMISION SERIAL por COM1"
        DB " - Protocolo HW: 9600,N,2,8",CR,LF,CR,LF
        DB "  [A] Para trasnmitir la secuencia ASCII indefinidamente",CR,LF,"$"

;=============================================================================
;   AREA DESTINADA AL PROCEDURE DEL PROGRAMMA                              
;=============================================================================
INIserial:
                              ;
        MOV     DX,03FBH      ;REGISTRO DE CONTROL DE LINEA
        MOV     AL,80H        ;
        OUT     DX,AL         ;
        MOV     AX,000CH      ;PREDISPONE EL ACCESO AL REGISTRO DIVISOR
        MOV     DX,03F8H      ;9600 BAUD
        OUT     DX,AL         ;
        MOV     AL,AH         ;
        MOV     DX,03F9H      ;
        OUT     DX,AL         ;
                              ;
                              ;REGISTRO CONTROL DE LINEA
        MOV     DX,03FBH      ;PREDISPONE LA RETRASMISION CON EL PARAMETRO
        MOV     AL,07H        ;NINGUNA PARIDAD, 2 STOP BIT, 8 DATA BIT
        OUT     DX,AL         ;
                              ;
                              ;REGISTRO CONTROL DEL MODEM
        MOV     DX,03FCH      ;INICIALIZAA EL REGISTRO PARA CONDICIONES 
        MOV     AL,03H        ;NORMALES
        OUT     DX,AL         ;
                              ;REGISTRO DEE ABILITACION DED INTERRUPCION 
        MOV     DX,03F9H      ;DESABILITA TODAS LAS INTERRUPCIONES
        MOV     AL,00H        ;
        OUT     DX,AL         ;
                              ;
                              ;
        RET

;=============================================================================
TxD_0:  MOV     BL,AL         ;
                              ;
        MOV     DX,03FDH      ;REGISTRO DE ESTADO DE LA LINEA
TxD101: IN      AL, DX        ;
        TEST    AL,20H        ;
        JZ      TxD101        ;
                              ;
        MOV     DX,03F8H      ;REGISTRO BUFFER DE TRASMISION (EN ESCRITURA)
        MOV     AL,BL         ;
        OUT     DX,AL         ;
                              ;
        RET

;=============================================================================
                              ;===============================================
TxD0Com1 proc   NEAR          ;       AREA DEDICADA AL MAIN PROGRAM           
                              ;===============================================
;=============================================================================
                              ;
        CALL    INIserial     ;INICILIZA LOS REGISTROS DEL PUERTO COM1
                              ;
        MOV     AH,00H        ;CLEAR SCREEN
        MOV     AL,03H        ;
        INT     10H           ;VIDEO DISPLAY SERVICES POR BIOS

        LEA     DX,Testo      ;INPRIME UN STRING A NIVEL DEL DOS
        MOV     AH,09H        ;
        INT     21H           ;SERVICIOS DEL SISTEMA DOS

xxx00:  MOV     AH,00H        ;ESPERA SE PRESIONE UNA TECLA A NIVEL DEL BIOS
        INT     16H           ;KEYBOARD SERVICES 
        AND     AL,11011111B  ;<-no borrar
        CMP     AL,'A'        ;
        JNZ     xxx00         ;
        ;---------------------------------------------------------------------

xxx01:  MOV     AL,21H ;00H   ;PREPARA EL PRIMER CARACTER A TRASMITIR
							  ;21H = 33 = ! Primer caracter imprimible.
        MOV     CS:[DatTxD],AL;
xxx02:  MOV     AL,CS:[DatTxD];

        CALL    TxD_0         ;LLAMA PROCEDIMIENTO
                              ;
        PUSH    AX            ;
        MOV     BH,00H        ;
        MOV     AH,0EH        ;IMPRIME UN CARACTER  A NIVEL DEL BIOS
        INT     10H           ;
        POP     AX            ;
        INC     AL            ;PREPARA EL PROXIMO CARACTER 

        CMP     AL,7FH 		  ;COMPARA SI ES IGUAL AL CARACTER 127 
        JE      xxx01         ;sI ES IGUAL SALTA A xxx01

        MOV     CS:[DatTxD],AL;EL CARACTER LO INSERTAEN EL DEPOSITO

        MOV     AH,01H        ;CONTROLA LA PRESION DE ALGUNA TECLA
        INT     16H           ;
        JZ      xxx02         ;
        JMP     _OUT
        ;---------------------------------------------------------------------

xxx04:  MOV     AH,00H        ;ESPERA LA PRESION DE UNA TECLA CON "ESC"
        INT     16H           ;VUELVE AL DOS
        CMP     AL,ESC_       ;
        JZ      _OUT          ;
                              ;
        ;---------------------------------------------------------------------
_OUT:   MOV     AH,4CH        ;Torna al DOS
        INT     21H
TxD0Com1 ENDP
_prog   ENDS
        END INIZIO
